# PLDAPSchema Class Reference

`#include <pldap.h>`

Inheritance diagram for PLDAPSchema:

List of all members.

## Public Types

typedef std::list< Attribute > | attributeList
| AttibuteUnknown = -1
| AttributeString
| AttributeBinary
| AttributeNumeric
enum | AttributeType { AttibuteUnknown = -1, AttributeString, AttributeBinary, AttributeNumeric }

## Public Member Functions

| PLDAPSchema ()
void | OnReceivedAttribute (const PString &attribute, const PString &value)
void | OnSendSchema (PArray< PLDAPSession::ModAttrib > &attributes, PLDAPSession::ModAttrib::Operation op=PLDAPSession::ModAttrib::Add)
void | LoadSchema ()
PStringList | SchemaName ()
virtual void | AttributeList (attributeList &)
PStringList | GetAttributeList ()
PBoolean | Exists (const PString &attribute)
PBoolean | SetAttribute (const PString &attribute, const PString &value)
PBoolean | SetAttribute (const PString &attribute, const PBYTEArray &value)
PBoolean | GetAttribute (const PString &attribute, PString &value)
PBoolean | GetAttribute (const PString &attribute, PBYTEArray &value)
AttributeType | GetAttributeType (const PString &attribute)

## Static Public Member Functions

static PLDAPSchema * | CreateSchema (const PString &schemaname, PPluginManager *pluginMgr=NULL)
static PStringList | GetSchemaNames (PPluginManager *pluginMgr=NULL)
static PStringList | GetSchemaFriendlyNames (const PString &schema, PPluginManager *pluginMgr=NULL)

## Protected Types

typedef std::map< PString, PString > | ldapAttributes
typedef std::map< PString, PBYTEArray > | ldapBinAttributes

## Protected Attributes

attributeList | attributelist
ldapAttributes | attributes
ldapBinAttributes | binattributes

## Classes

class | Attribute

## Member Typedef Documentation

typedef std::list<Attribute> PLDAPSchema::attributeList

typedef std::map<PString,PString> PLDAPSchema::ldapAttributes `[protected]`

typedef std::map<PString,PBYTEArray> PLDAPSchema::ldapBinAttributes `[protected]`

## Member Enumeration Documentation

enum PLDAPSchema::AttributeType

Enumerator:

  AttibuteUnknown |
  AttributeString |
  AttributeBinary |
  AttributeNumeric |

## Constructor & Destructor Documentation

PLDAPSchema::PLDAPSchema | ( |  | ) |

## Member Function Documentation

virtual void PLDAPSchema::AttributeList | ( | attributeList & |  | ) | `[inline, virtual]`

static PLDAPSchema* PLDAPSchema::CreateSchema | ( | const PString & | schemaname,
|  | PPluginManager * | pluginMgr = `NULL` |
| ) |  |  | `[static]`

PBoolean PLDAPSchema::Exists | ( | const PString & | attribute | ) |

PBoolean PLDAPSchema::GetAttribute | ( | const PString & | attribute,
|  | PBYTEArray & | value |
| ) |  |  |

PBoolean PLDAPSchema::GetAttribute | ( | const PString & | attribute,
|  | PString & | value |
| ) |  |  |

PStringList PLDAPSchema::GetAttributeList | ( |  | ) |

AttributeType PLDAPSchema::GetAttributeType | ( | const PString & | attribute | ) |

static PStringList PLDAPSchema::GetSchemaFriendlyNames | ( | const PString & | schema,
|  | PPluginManager * | pluginMgr = `NULL` |
| ) |  |  | `[static]`

static PStringList PLDAPSchema::GetSchemaNames | ( | PPluginManager * | pluginMgr = `NULL` | ) | `[static]`

void PLDAPSchema::LoadSchema | ( |  | ) |

void PLDAPSchema::OnReceivedAttribute | ( | const PString & | attribute,
|  | const PString & | value |
| ) |  |  |

void PLDAPSchema::OnSendSchema | ( | PArray< PLDAPSession::ModAttrib > & | attributes,
|  | PLDAPSession::ModAttrib::Operation | op = `PLDAPSession::ModAttrib::Add` |
| ) |  |  |

PStringList PLDAPSchema::SchemaName | ( |  | ) | `[inline]`

PBoolean PLDAPSchema::SetAttribute | ( | const PString & | attribute,
|  | const PBYTEArray & | value |
| ) |  |  |

PBoolean PLDAPSchema::SetAttribute | ( | const PString & | attribute,
|  | const PString & | value |
| ) |  |  |

## Member Data Documentation

attributeList PLDAPSchema::attributelist `[protected]`

ldapAttributes PLDAPSchema::attributes `[protected]`

ldapBinAttributes PLDAPSchema::binattributes `[protected]`

The documentation for this class was generated from the following file:

- pldap.h